Bug 1412680 (CVE-2016-2337) - CVE-2016-2337 ruby: TclTkIp ip_cancel_eval type confusion vulnerability
Summary: CVE-2016-2337 ruby: TclTkIp ip_cancel_eval type confusion vulnerability
Keywords:
Status: CLOSED WONTFIX
Alias: CVE-2016-2337
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On:
Blocks: 1412685
TreeView+ depends on / blocked
 
Reported: 2017-01-12 14:39 UTC by Andrej Nemec
Modified: 2021-02-17 02:47 UTC (History)
24 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-01-18 00:21:24 UTC


Attachments (Terms of Use)

Description Andrej Nemec 2017-01-12 14:39:09 UTC
Type Confusion exists in _cancel_eval Ruby’s TclTkIp class method. Attacker passing different type of object than String as “retval” argument can cause arbitrary code execution.

References:

http://www.talosintelligence.com/reports/TALOS-2016-0031/

Comment 2 Doran Moppert 2017-01-17 23:53:22 UTC
This vulnerability requires that the attacker can execute arbitrary Ruby code under elevated privileges, which is already a bad idea.

The "cancel_eval" function is only available when tcl-8.6 is present.  Red Hat Enterprise Linux presently only ships tcl<=8.5, so this vulnerability can not be exploited.

Comment 3 Doran Moppert 2017-01-18 00:15:12 UTC
> This vulnerability requires that the attacker can execute arbitrary Ruby code under elevated privileges, which is already a bad idea.

The 'tk' module will only load from within an X session (eg $DISPLAY pointing to a valid X server), making conditions for exploitation even more unlikely.

Comment 4 Doran Moppert 2017-01-18 00:20:45 UTC
Statement:

Red Hat Product Security has rated this issue as having Moderate security
impact. This issue is not currently planned to be addressed in future
updates. For additional information, refer to the Issue Severity
Classification: https://access.redhat.com/security/updates/classification/.


Note You need to log in before you can comment on or make changes to this bug.